#ifndef __abr_h
#define __abr_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#define ROW_LENGTH 256

#define boolean int
#define TRUE  1
#define FALSE 0


#define EMPTY_TREE  NULL

typedef struct _nodo nodo;
struct _nodo
{
  int val;
  nodo *padre;
  nodo *Ts;
  nodo *Td;
};

typedef nodo *ABR;


ABR creaABR ();

void distruggeABR (ABR *pT);

boolean ABRvuoto (ABR T);

boolean memberABR (int i, ABR T);

ABR insertABR (int i, ABR T);

ABR deleteABR (int i, ABR T);

int minABR (ABR T);

int maxABR (ABR T);

void stampaABR (ABR T);

#endif
